﻿//css_ref System.Data;
//css_ref System.Transactions;
//css_ref System.Xml;
//css_ref Interop.SAPbobsCOM.dll;
//css_ref log4net.dll;
//css_ref Produmex.Foundation.Data.dll;
//css_ref Produmex.Foundation.Data.Sbo.dll;
//css_ref Produmex.Foundation.dll;
//css_ref Produmex.Foundation.Sbo.dll;
//css_ref Produmex.Sbo.Logex.Data.dll;
//css_ref Produmex.Sbo.Logex.MLS.dll;

using System;
using System.Reflection;
using System.Transactions;
using Produmex.Foundation.Data.Sbo;
using Produmex.Foundation.Data.Sbo.Attributes;
using Produmex.Foundation.Data.Sbo.BusinessObjects;
using Produmex.Foundation.Data.Sbo.BusinessObjects.Convertors;
using Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions;
using Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.Tables;
using Produmex.Foundation.Data.Sbo.Providers;
using Produmex.Foundation.Data.Sbo.Utilities;
using Produmex.Foundation.Diagnostics;
using Produmex.Foundation.Reflection;
using Produmex.Foundation.Resources;
using Produmex.Sbo.Logex.Data;
using Produmex.Sbo.Logex.Data.BusinessObjects;
using Produmex.Sbo.Logex.Data.BusinessObjects.Definitions;
using Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.Tables;
using Produmex.Sbo.Logex.Data.Providers;
using Produmex.Sbo.Logex.MLS;
using Produmex.Sbo.Logex.MLS.BusinessObjects.Definitions;
using Produmex.Sbo.Logex.MLS.BusinessObjects.Definitions.Tables;
using Produmex.Sbo.Logex.MLS.Extensions.Interfacing;
using Produmex.Sbo.Logex.MLS.BusinessObjects.Convertors;


namespace AddUpdateData
{
    class Program
    {
        const string CONNECTION_STRING = "Server=localhost;CompanyDB=MLS;ExtraDb=PMX_MLS;UseTrusted=False;DbUserName=sa;DbPassword=B1Admin;UserName=manager;Password=produmex;Pooling=True;MinPoolSize=2;MaxPoolSize=10;ServerType=MSSQL2005;DBCultureInfo=en-US;LicenseServer=localhost:30000";
        const string SCRIPT_ROOT = @"..\WorkflowScripts";


        /// <summary>
        /// Used for logging
        /// </summary>
        private static readonly ILog s_log = LogProvider.GetLogger(MethodInfo.GetCurrentMethod().DeclaringType);

        static void Main( string[] args )
        {
            using (TransactionScope scope = PmxDbConnection.GetNewTransactionScope())
            {
                using (SboConnection conn = new SboConnection(CONNECTION_STRING))
                {
                    conn.Open(); //Open connection to SAP
                    Console.WriteLine("Connection is open to database");

                    Console.WriteLine("Add tables");

                    RunTableSqlScript("PMX_MLS_PUPR.sql", conn);


                    Console.WriteLine("Add views");

                    RunViewSqlScript("PMX_MLS_TRANS_O_FLEX.sql", conn);


                    Console.WriteLine("Add Extensions");
                    //

                    AddUpdateExtension(SboSalesDeliveryInterfaceMLS.IDs.ExtCode, "SBO sales delivery im-/exporter for MLS", typeof(Produmex.Sbo.Logex.MLS.Extensions.Interfacing.SboSalesDeliveryInterfaceMLS), Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxExtensionTypeCodes.IINTERFACING_SBOSALESDELIVERY, conn);




                    Console.WriteLine("Add update Config data");
                    AddUpdatePmxConfig(PmxConfigCodesMLS.GrossPurchasePriceList.NAME, PmxConfigCodesMLS.GrossPurchasePriceList.DESCRIPTION, Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_INT32_CONVERTOR, true, "1", conn);
                    AddUpdatePmxConfig(PmxConfigCodesMLS.NetPurchasePriceList.NAME, PmxConfigCodesMLS.NetPurchasePriceList.DESCRIPTION, Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_INT32_CONVERTOR, true, "2", conn);
                    AddUpdatePmxConfig(PmxConfigCodesMLS.LandedCostPurchasePriceList.NAME, PmxConfigCodesMLS.LandedCostPurchasePriceList.DESCRIPTION, Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_INT32_CONVERTOR, true, "3", conn);

                    Console.WriteLine("Add UDF");
                    SboUserFieldMDProvider udfProv = new SboUserFieldMDProvider(conn);
                    //Add Klant-/leveranciersgroepnaam to BP group
                    udfProv.AddUpdateUserfield(SboCardGroupsTable.NAME, new SboColumnDefinitionAttribute(PmxCardGroupsTableMLS.Columns.BpGroupName.NAME, PmxCardGroupsTableMLS.Columns.BpGroupName.DESCRIPTION, SboFieldType.Alpha, 50, SboFieldSubType.None));
                    udfProv.AddUpdateUserfield(SboCountryTable.NAME, new SboColumnDefinitionAttribute(PmxCountryTableMLS.Columns.NumericCountryCode.NAME, PmxCountryTableMLS.Columns.NumericCountryCode.DESCRIPTION , SboFieldType.Alpha, 3, SboFieldSubType.None));
                    udfProv.AddUpdateUserfield(SboAlternateCatNumTable.NAME, new SboColumnDefinitionAttribute(PmxAlternateCatNumTableMLS.Columns.CatNum.NAME, PmxAlternateCatNumTableMLS.Columns.CatNum.DESCRIPTION, SboFieldType.Alpha, 30, SboFieldSubType.None));


                    udfProv.AddUpdateUserfield(SboSalesDeliveryNoteTable.NAME, 
                        new SboColumnDefinitionAttribute(PmxDocumentColumnsMLS.NumberOfColli.NAME, 
                            PmxDocumentColumnsMLS.NumberOfColli.DESCR, 
                            PmxDocumentColumnsMLS.NumberOfColli.TYPE, 
                            PmxDocumentColumnsMLS.NumberOfColli.SIZE, 
                            PmxDocumentColumnsMLS.NumberOfColli.SUB_TYPE));
                    udfProv.AddUpdateUserfield(SboSalesDeliveryNoteTable.NAME, 
                        new SboColumnDefinitionAttribute(PmxDocumentColumnsMLS.NumberOfHalfPallets.NAME,
                            PmxDocumentColumnsMLS.NumberOfHalfPallets.DESCR,
                            PmxDocumentColumnsMLS.NumberOfHalfPallets.TYPE,
                            PmxDocumentColumnsMLS.NumberOfHalfPallets.SIZE,
                            PmxDocumentColumnsMLS.NumberOfHalfPallets.SUB_TYPE));
                    udfProv.AddUpdateUserfield(SboSalesDeliveryNoteTable.NAME, 
                        new SboColumnDefinitionAttribute(PmxDocumentColumnsMLS.NumberOfPallets.NAME,
                            PmxDocumentColumnsMLS.NumberOfPallets.DESCR,
                            PmxDocumentColumnsMLS.NumberOfPallets.TYPE,
                            PmxDocumentColumnsMLS.NumberOfPallets.SIZE,
                            PmxDocumentColumnsMLS.NumberOfPallets.SUB_TYPE));


                    // document lines
                    udfProv.AddUpdateUserfield(SboPurchaseOrderLineTable.NAME, new SboColumnDefinitionAttribute(PmxDocumentLineColumnsMLS.Discount.NAME, PmxDocumentLineColumnsMLS.Discount.DESCR, PmxDocumentLineColumnsMLS.Discount.TYPE, PmxDocumentLineColumnsMLS.Discount.SIZE, PmxDocumentLineColumnsMLS.Discount.SUB_TYPE));
                    udfProv.AddUpdateUserfield(SboPurchaseOrderLineTable.NAME, new SboColumnDefinitionAttribute(PmxDocumentLineColumnsMLS.Surcharge.NAME, PmxDocumentLineColumnsMLS.Surcharge.DESCR, PmxDocumentLineColumnsMLS.Surcharge.TYPE, PmxDocumentLineColumnsMLS.Surcharge.SIZE, PmxDocumentLineColumnsMLS.Surcharge.SUB_TYPE));
                    udfProv.AddUpdateUserfield(SboPurchaseOrderLineTable.NAME, new SboColumnDefinitionAttribute(PmxDocumentLineColumnsMLS.DiscountAdditionalCosts.NAME, PmxDocumentLineColumnsMLS.DiscountAdditionalCosts.DESCR, PmxDocumentLineColumnsMLS.DiscountAdditionalCosts.TYPE, PmxDocumentLineColumnsMLS.DiscountAdditionalCosts.SIZE, PmxDocumentLineColumnsMLS.DiscountAdditionalCosts.SUB_TYPE));
                    udfProv.AddUpdateUserfield(SboPurchaseOrderLineTable.NAME, new SboColumnDefinitionAttribute(PmxDocumentLineColumnsMLS.PricePerThousand.NAME, PmxDocumentLineColumnsMLS.PricePerThousand.DESCR, PmxDocumentLineColumnsMLS.PricePerThousand.TYPE, PmxDocumentLineColumnsMLS.PricePerThousand.SIZE, PmxDocumentLineColumnsMLS.PricePerThousand.SUB_TYPE));

                    udfProv.AddUpdateUserfield(SboPurchaseOrderLineTable.NAME, new SboColumnDefinitionAttribute(PmxDocumentLineColumnsMLS.TransportCosts.NAME, PmxDocumentLineColumnsMLS.TransportCosts.DESCR, PmxDocumentLineColumnsMLS.TransportCosts.TYPE, PmxDocumentLineColumnsMLS.TransportCosts.SIZE, PmxDocumentLineColumnsMLS.TransportCosts.SUB_TYPE));
                    udfProv.AddUpdateUserfield(SboPurchaseOrderLineTable.NAME, new SboColumnDefinitionAttribute(PmxDocumentLineColumnsMLS.ExtraCosts.NAME, PmxDocumentLineColumnsMLS.ExtraCosts.DESCR, PmxDocumentLineColumnsMLS.ExtraCosts.TYPE, PmxDocumentLineColumnsMLS.ExtraCosts.SIZE, PmxDocumentLineColumnsMLS.ExtraCosts.SUB_TYPE));



                    // Item master data Price Setting
                    SboColumnDefinitionAttribute priceSettingColumnDef = new SboColumnDefinitionAttribute(PmxItemMLSTable.Columns.PriceSetting.NAME, PmxItemMLSTable.Columns.PriceSetting.DESCR, PmxItemMLSTable.Columns.PriceSetting.TYPE, PmxItemMLSTable.Columns.PriceSetting.SIZE, PmxItemMLSTable.Columns.PriceSetting.SUB_TYPE);
                    priceSettingColumnDef.SboBOColumnConverterType = typeof(PmxPriceSettingConvertorMLS);
                    priceSettingColumnDef.DefaultValue = PmxPriceSettingColumnValues.Stuk.VALUE;
                    priceSettingColumnDef.IsMandatory = true;
                    udfProv.AddUpdateUserfield(SboItemTable.NAME, priceSettingColumnDef);




                    SboColumnDefinitionAttribute hideColumn = new SboColumnDefinitionAttribute(PmxDocumentColumnsMLS.HidePurchasePopUp.NAME,
                          PmxDocumentColumnsMLS.HidePurchasePopUp.DESCR,
                          PmxDocumentColumnsMLS.HidePurchasePopUp.TYPE,
                          PmxDocumentColumnsMLS.HidePurchasePopUp.SIZE,
                          PmxDocumentColumnsMLS.HidePurchasePopUp.SUB_TYPE);
                    hideColumn.DefaultValue = PmxDocumentColumnsMLS.HidePurchasePopUp.DEFAULT_VALUE;
                    hideColumn.SboBOColumnConverterType = typeof(SboBooleanConvertor);
                    hideColumn.IsMandatory = true;
                    udfProv.AddUpdateUserfield(SboPurchaseOrderTable.NAME, hideColumn);


                    


                }

                //Complete transaction
                scope.Complete();
            }


            using (TransactionScope scope = PmxDbConnection.GetNewTransactionScope())
            {
                using (PmxDbConnectionSql dbConn = new PmxDbConnectionSql(CONNECTION_STRING))
                {
                    dbConn.Open(); //Open connection to SAP
                    Console.WriteLine("Connection is open to database");
                    Console.WriteLine("Add workflows");

                    AddUpdateWorkflowScript(PmxWorkflowExecutionTypes.HOOK_FLOW, "SalesDeliveryCreatedHookScript",
                        SCRIPT_ROOT + @"\WorkflowScript_SalesDeliveryCreatedHookScript\WorkflowScript_SalesDeliveryCreatedHookScript.cs", dbConn);

                    AddUpdateWorkflowScript(PmxWorkflowExecutionTypes.SUB_FLOW, "PrintSalesDeliveryDocumentsScript",
                        SCRIPT_ROOT + @"\WorkflowScript_PrintSalesDeliveryDocumentsScript\WorkflowScript_PrintSalesDeliveryDocumentsScript.cs", dbConn);


                }

                //Complete transaction
                scope.Complete();
                Console.WriteLine("Done ...");
            }
        }

        /// <summary>
        /// Add/Update script workflow
        /// </summary>
        /// <param name="executionType">Type of the execution.</param>
        /// <param name="name">The name of the flow.</param>
        /// <param name="sourceFilePath">Name of the file.</param>
        /// <param name="sqlConn">The SQL conn.</param>
        private static void AddUpdateWorkflowScript(string executionType, string name, string sourceFilePath, PmxDbConnectionSql sqlConn)
        {
            PmxWorkflowProvider wfProvider = new PmxWorkflowProvider(sqlConn);
            PmxWorkflow workflow = wfProvider.GetWorkflowByName(name);
            PmxWorkflowScriptProvider wfscProvider = new PmxWorkflowScriptProvider(sqlConn);
            PmxWorkflowScript bo = null;
            if (workflow == null)
            {
                //add the workflow
                bo = wfscProvider.GetNewBO();
                bo.Name = name;
                wfscProvider.AddBO(bo);
            }
            else
            {
                if (workflow.ObjType == Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxObjectTypes.PmxWorkflowScript)
                {
                    bo = wfscProvider.GetBO(workflow.InternalKey);

                }
            }

            if (bo != null)
            {
                bo.ExecutionType = executionType;

                wfscProvider.UpdateSourceFromFileAndCompile(bo, sourceFilePath, sqlConn);
            }

        }


        /// <summary>
        /// Add/update application type
        /// </summary>
        /// <param name="code">The code of the config</param>
        /// <param name="name">The name of the config</param>
        /// <param name="convertorCode">The convertor code.</param>
        /// <param name="isSystemConfig">if set to <c>true</c> [is system config].</param>
        /// <param name="configValue">The config value.</param>
        /// <param name="conn">The conn.</param>
        private static void AddUpdatePmxConfig(string code, string name, string convertorCode, bool isSystemConfig, string configValue, PmxDbConnection conn)
        {
            PmxConfigProvider prov = new PmxConfigProvider(conn);
            PmxConfig bo = null;
            try
            {
                bool newBo = false;
                bo = prov.GetBO(code);
                if (bo == null)
                {
                    newBo = true;
                    bo = prov.GetNewBO();
                    bo.Code = code;
                }
                bo.Name = name;
                bo.ConvertorCode = convertorCode;
                bo.IsSystemConfig = isSystemConfig;
                bo.ConfigValue = configValue;
                if (newBo)
                {
                    prov.AddBO(bo);
                }
                else
                {
                    //prov.UpdateBO(bo);
                }
            }
            finally
            {
                if (bo != null) bo.Dispose();
            }
        }



        /// <summary>
        /// Runs the table SQL script.
        /// </summary>
        /// <param name="tableScript">The table script.</param>
        /// <param name="conn">The conn.</param>
        private static void RunTableSqlScript(string tableScript, PmxDbConnection conn)
        {
            string content = ResourceHelper.ReadResourceContentAsString(Assembly.GetAssembly(typeof(Produmex.Sbo.Logex.MLS.SboCommands)), "Produmex.Sbo.Logex.MLS.Scripts.Tables." + tableScript);
            SboRecordsetHelper.RunSqlScript(s_log, content, conn);
        }

        /// <summary>
        /// Runs the view SQL script.
        /// </summary>
        /// <param name="viewScript">The view script.</param>
        /// <param name="conn">The conn.</param>
        private static void RunViewSqlScript(string viewScript, PmxDbConnection conn)
        {
            string content = ResourceHelper.ReadResourceContentAsString(Assembly.GetAssembly(typeof(Produmex.Sbo.Logex.MLS.SboCommands)), "Produmex.Sbo.Logex.MLS.Scripts.Views." + viewScript);
            SboRecordsetHelper.RunSqlScript(s_log, content, conn);
        }
        /// <summary>
        /// Runs the stored procedure SQL script.
        /// </summary>
        /// <param name="spScript">The sp script.</param>
        /// <param name="conn">The conn.</param>
        private static void RunStoredProcedureSqlScript(string spScript, PmxDbConnection conn)
        {
            string content = ResourceHelper.ReadResourceContentAsString(Assembly.GetAssembly(typeof(Produmex.Sbo.Logex.MLS.SboCommands)), "Produmex.Sbo.Logex.MSL.Scripts.StoredProcedures." + spScript);
            SboRecordsetHelper.RunSqlScript(s_log, content, conn);
        }

        /// <summary>
        /// Add/Update <see cref="PmxExtension"/>
        /// </summary>
        /// <param name="code">The code of the extension.</param>
        /// <param name="name">The name of the extension.</param>
        /// <param name="type">The type of the extension.</param>
        /// <param name="extensionTypeCode">The extension type code.</param>
        /// <param name="conn">The SBO connection</param>
        private static void AddUpdateExtension( string code, string name, Type type, string extensionTypeCode, SboConnection conn )
        {
            PmxExtensionProvider prov = new PmxExtensionProvider( conn );
            PmxExtension extension = null;
            try
            {
                bool newBO = false;
                extension = prov.GetBO( code );
                if ( extension == null )
                {
                    newBO = true;
                    extension = prov.GetNewBO();
                    extension.Code = code;
                }
                extension.Name = name;
                extension.ExtensionTypeCode = extensionTypeCode;
                extension.Type = ReflectionHelper.GetTypeAndAssemblyName( type );
                if ( newBO )
                {
                    prov.AddBO( extension );
                }
                else
                {
                    prov.UpdateBO( extension );
                }
            }
            finally
            {
                if ( extension != null ) extension.Dispose();
            }
        }


    }
}
