IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[PMX_SP_MLS_COLLI_Label]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[PMX_SP_MLS_COLLI_Label]
GO


-- =============================================
-- Author:		Produmex
-- Create date: 
-- Description:	Colli label for MLS
-- =============================================
ALTER PROCEDURE [dbo].[PMX_SP_MLS_COLLI_Label] 
	-- Add the parameters for the stored procedure here
	@docEntry int = 0,
	@colliType nvarchar (20),
	@totalLabels int = 0,
	@currentLabel int = 0,
	@currentLabelColli int = 0
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

	SELECT ODLN.DocNum,ODLN.CardName,ODLN.Address,@colliType AS ColliType, @totalLabels As TotalLabels, @currentLabel As Currentlabel, RIGHT (('000000' + Dln12.ZipCodeS),5) As Zipcode,RIGHT(OCRY.U_PMX_MLS_LAND,2) As CountryCode, 
	CASE @colliType WHEN 'COLLIE' THEN '000'
WHEN '1/2 PAL' then 	'000'
WHEN 'PALLET' THEN  '100'
END AS TypeLogCarrier
	,
	'58871' + CASE @colliType WHEN '1/2 PAL' THEN right (convert(varchar,ODLN.Docnum),7) + '0' ELSE '0'+ right (convert(varchar,ODLN.Docnum),7) end 
	+
		CASE @colliType WHEN 'COLLIE' THEN '000'
WHEN '1/2 PAL' then 	'100'
WHEN 'PALLET' THEN  '100' END
+ convert(varchar,@currentLabelColli) + 
RIGHT(OCRY.U_PMX_MLS_LAND,2)
+
RIGHT (('000000' + ISNULL(Dln12.ZipCodeS,DLN12.ZipCodeB)),5)

	AS BarcodeData
	
	From ODLN
	Left outer JOIN DLN12 on ODLN.DocEntry = DLN12.DocEntry
	LEFT OUTER JOIN OCRY ON DLN12.CountryS = OCRY.Code
	Where ODLN.DocEntry = @docEntry
	
	

END

GO

SET ANSI_NULLS OFF
GO
SET QUOTED_IDENTIFIER OFF
GO

